'-----------------------------------------------------------------
' CCTools IC-Bus-Routinen fr Open-Micro/Open-Mini
' zum MAX520 DA-Wandler und I2C-DA4 HS (#1844)
' CCTools 2005 (http://cctools.hs-control.de)
'-----------------------------------------------------------------
' Die Routinen bauen auf den IC-Bus-ASM-Treiber (om_i2c.bas)
' von Dietmar Harlos auf. Dieser kann von C-Control-Intern geladen
' werden (http://ccintern.dharlos.de)
' Das Bsp. ist in OC-Basic(von Dietmar Harlos) geschrieben.
'-----------------------------------------------------------------
' Die hufigsten IC-Bus-Adressen:
' &h20 - &h2E    MAX7311 16Bit Portexpander
' &h30 - &h3E    MAX7311 16Bit Portexpander
' &h40 - &h4E    MAX7311 16Bit Portexpander
' &h40 - &h4E    PCF8574 Portexpander
' &h50 - &h5E    MAX7311 16Bit Portexpander
' &h50 - &h5E    MAX520 4ch. 8Bit DA-Wandler
' &h68 - &h6E    MAX4572 Analog-Schalter (write only)
' &h70 - &h7E    PCF8574A Portexpander
' &h90 - &h9E    PCF8591 4ch. 8Bit AD-Wandler
' &h90 - &h9E    DS1631 12Bit Temperatursensor
' &hA0 - &hA2    PCF8583 Uhrenbaustein
' &hA0 - &hA6    serielle EEProms 24C128 - 24C512
' &hA0 - &hAE    serielle EEProms 24C01 - 24C64
' &hA0 - &hAE    MAX7311 16Bit Portexpander
' &hB0 - &hBE    MAX7311 16Bit Portexpander
' &hC0 - &hCE    MAX7311 16Bit Portexpander
' &hD0 - &hDE    MAX7311 16Bit Portexpander
'-----------------------------------------------------------------

define SCL PORT[5] ' Pull-Up mit je 10k empfohlen,
define SDA PORT[6] ' wenn die Busleitungen etwas lnger gezogen werden (>1m)

define led port[4]
define i byte[1] 'temporres Byte
define x byte[2] 'temporres Byte
define j byte[3] 'temporres Byte (nur fr Printfunktion)

define wert byte[4]
define data byte[5]
define max520_addr &h50

gosub i2c_init ' "Initialisierung" des IC-Busses

max520_init(max520_addr)

data=1
#loop

 MAX520_set(max520_addr,0,wert) ' DA-Ausgang 0 setzen
 MAX520_set(max520_addr,1,wert) ' DA-Ausgang 1 setzen
 MAX520_set(max520_addr,2,wert) ' DA-Ausgang 2 setzen
 MAX520_set(max520_addr,3,wert) ' DA-Ausgang 3 setzen

 'Ausgabe des DA-Werts ber Terminal:
 put 12
 print wert;
 if wert=255 and data=1 then data=255 '^=step -1
 if wert=0 and data=255 then data=1
 wert=wert+data
 pause 10

goto loop

'Programmbeginn


'---------------------------------------
' MAX520-Routinein
'---------------------------------------

#MAX520_init '(addr)
 pop i
 i2c_start
 i2c_write i
 i2c_write &h10
 i2c_stop
return

#MAX520_pwrDown '(addr)
 pop i
 i2c_start
 i2c_write i
 i2c_write &h08
 i2c_stop
return

#MAX520_set '(addr, port, value)
 pop j : REMOVETOS
 pop x : REMOVETOS
 pop i
 i2c_start
 i2c_write(i)
 i2c_write(x)
 i2c_write(j)
 i2c_stop
return


'---------------------------------------
' Einbinden der IC-Bus-Routinen
'---------------------------------------
include "om_i2c.bas"

